

/******************************************************************************
* 
* 
*   SERVO_CAMERA_III
 
*   C/PIC 12F675
*
*   AUTOR: CLAUDIO LARIOS
*
*   DATA: 12/09/2015
* 
*   OBJETIVO: MOVIMENTAR CAMERA INSTALADA EM SUPORTE COM MOVIMENTOS HORIZONTAIS
*   E VERTICAIS FEITOS POR 2 SERVOS DE 0-2MS( 3 FIOS)
*   PODER USAR OS POTENCIOMETROS DO CONTROLE DO PS (TIPO JOYSTICK)
*   ACRESCENTADO MOVIMENTO DE VARREDURA HORIZONTAL
*   
*   ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
* 
 ******************************************************************************/
#include <xc.h>
#define _XTAL_FREQ 4000000//frequncia usada (osc.interno))


// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG
#pragma config FOSC = INTRCIO   // Oscillator Selection bits (INTOSC oscillator: I/O function on GP4/OSC2/CLKOUT pin, I/O function on GP5/OSC1/CLKIN)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-Up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = OFF      // GP3/MCLR pin function select (GP3/MCLR pin function is digital I/O, MCLR internally tied to VDD)
#pragma config BOREN = OFF      // Brown-out Detect Enable bit (BOD disabled)
#pragma config CP = OFF         // Code Protection bit (Program Memory code protection is disabled)
#pragma config CPD = OFF        // Data Code Protection bit (Data memory code protection is disabled)

#define cn1  GPIO5              //saida 1 pwm para o servo 0-2 mseg
#define cn2  GPIO4              //saida 2 pwm para o servo 0-2 mseg
#define led  GPIO2              //led indicador de varredura ligada

//limites de excurso dos servos horizontais e verticais
#define lim_minv 85   //determina o limite horrio max. do servo vertical
#define lim_minh 65   //determina o limite horrio max. do servo horizontal
#define lim_maxv 180  //determina o limite anti-horrio max. do servo vertical
#define lim_maxh 180  //determina o limite anti-horrio max. do servo horizontal
#define lim_initv 105  //posio ps reset do  servo vertical
#define lim_inith 105  //posio ps reset do  servo horizontal

#define p_total  220  //determina o periodo total (aprox.18 ms))
#define vel_inc  5   //determina a velocidade de reao dos joystick
#define vel_varr 70   //velocidade em modo varredura
#define v_estab  10   // estabiliza contra variaes da leitura do AD

char val1,val1a,val1b,val2,val2a,val2b,vez,aux,cnt1,cnt2;
bit f_var,f_dir,f_tr;
/*==============================================================================
              Rotina  de acionamento do servo
==============================================================================*/
void interrupt servo(){
   
    if(T0IF&T0IE){
        T0IF=0; //apaga flag
        cn1=0;//desliga canal 1 se ligado
        cn2=0;//desliga canal 2 se ligado
        T0IE=0;//desliga int do timer 0
    }
    if(TMR1IF){
         
        TMR1IF=0; //desliga flag do timer1
        TMR1H=p_total;
        TMR1L=0;
        if(++vez>1)vez=0;
        val1a=val1;
        val2a=val2;
        if(!vez)
        {cn1=1; TMR0= ~val1a;} //liga canal 1
        else 
        {cn2=1;TMR0= ~val2a;}//liga canal 2
        T0IF=0;//apaga flag do tmr0
        T0IE=1;//liga int do timer 0
       
    }
  
  
   }


/****************************************************************************
                 Programa Principal (Main)
 ****************************************************************************/  

void main(void){
    OPTION_REG=3;//liga pull ups geral TMR0/16
    WPU=0XFF; //pullup individuais
    TRISIO=0B001011;//in / outs
    GPIO=0;//zera ports
    CMCON=7;//desliga comparadores
    ANSEL=0b00100011;// conversor a/d canal 0 e 1
    ADCON0=0B00000001;//liga conversor
    TMR1H=p_total;//pr-carga
    TMR1L=0;//idem
    T1CON=1;//liga timer1 sem prescaller
    PEIE=1;//liga interrupo dos perifricos
    TMR1IE=1;//liga interrupo do timer 1
    T0IE=0;
    GIE=1;//liga geral das interrupes
    vez=0;
    val1=lim_inith;
    val2=lim_initv;
    val1a=val1;
    val2a=val2;
    f_var=0;
    f_tr=0;
    
 /****************************************************************************
                     Lao prinicipal de repetio
  ****************************************************************************/  
    for(;;){
        
        if(!GPIO3){f_tr=1;  __delay_ms(10);}
        if(GPIO3&&f_tr){
            f_var=!f_var;
            if(f_var) led=1;else led=0;
            f_tr=0;
        }//liga modo varredura
        
        
        if(!f_var){
        ADCON0=0B00000001;//liga conversor canal 0
        __delay_us(30);
        GO_DONE=1;
        while(GO_DONE);
         aux=ADRESH;
         if(aux>lim_maxh)aux=lim_maxh;//limita excurso do servo horizontal
         if(aux<lim_minh)aux=lim_minh;
         val1b=aux;
         if(val1!=val1b){
             if(!cnt1--){cnt1=v_estab; val1=val1b;}
         }
         else{cnt1=v_estab;}
         
        ADCON0=0B00000101;//liga conversor canal 1
        __delay_us(30);
        GO_DONE=1;
        while(GO_DONE);
        aux=ADRESH;
        val2b=aux;
         if(val2!=val2b){
             if(!cnt2--){cnt2=v_estab; val2=val2b;}
         }
         else{cnt2=v_estab;}
        
        if(aux>lim_maxv)aux=lim_maxv;
        if(aux<lim_minv)aux=lim_minv;
        val2b=aux;
        __delay_ms(vel_inc); //velocidade de incrementos
        
        
    }
        else{
            if(f_dir){
                if(++val1>=lim_maxh)f_dir=0;
            
            }
            else{
                
                if(--val1<=lim_minh)f_dir=1;
                
            }
            
            __delay_ms(vel_varr); //velocidade de incrementos
            
            
            
        }
       
                         
    }//for(;;)
     
    
    
}//main()

/********fim do programa *******Larios.Tecnologia.Ws****************************/